#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <sys/stat.h>
#include <pthread.h>
#include <signal.h>

void print_perms(struct stat *sb,char *name)
{
  char perms[10], *p;
  int i;


  if(S_ISLNK(sb->st_mode)) return;

     p = perms + 1;
     strcpy(perms,"----------");

     for(i = 0;i < 3; i++)
     {
        if(sb->st_mode & (S_IREAD  >> i * 3)) *p = 'r';
        p++;
        if(sb->st_mode & (S_IWRITE >> i * 3)) *p = 'w';
        p++;
        if(sb->st_mode & (S_IEXEC  >> i * 3)) *p = 'x';
        p++;
     }
     if(sb->st_mode & S_ISUID) perms[2] = 's'; // suid
     if(sb->st_mode & S_ISGID) perms[5] = 's'; // sgid 
     if(sb->st_mode & S_ISVTX) perms[8] = 't'; // sticky bit

     /* Filetype */
     switch(sb->st_mode & S_IFMT)
     {
        case S_IFBLK: perms[0] = 'b';
                      break;
        case S_IFCHR: perms[0] = 'c';
                      break;
        case S_IFDIR: perms[0] = 'd';
                      break;
        case S_IFIFO: perms[0] = 'f';
                      break;
        default:      perms[0] = '-';
     }
     printf("%s %s\n",perms,name);
 
}

int main(int argc,char **argv)
{
    struct stat st;
    
    if(argc != 2)
        printf("Usage %s <file>\n",argv[0]),exit(0);
 
    lstat(argv[1],&st);
    print_perms(&st,argv[1]);
}

