/* INCLUDES */
#include <stdio.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <unistd.h>
#include <pthread.h>
#include <errno.h>

/* PROTOTYPES */
int get_info(char *); 	// get a new task from the parent
void clone_main(void *); // the main function of the clones
void check_dir(DIR *,int *,char *,DIR **); // This opens and reads dirs
void check_perms(struct stat *,char *); // does the actual checking. 
                                 // it's a function because the parent uses it too
void perm2dig(char *,int); // convert rwx strings into a digit form
int checkaccess(struct stat *); // check access to a directory 

/* GLOBALS: vars used by parent and clones */
int parent; // parent pid

struct clone_info
  {
	pthread_mutex_t mutex;
	pthread_mutex_t sig_parent;
	char dir[1024];
  }info;

int show[4]; // holds the permissions that should be reported

/* DEFINES */
//#define DEBUG               // enable debug messages
#define THREADMAX 10        // Maximum number of threads
#define THREADDEFAULT 4     // default number of threads
#define MAXFILELEN 4096     // maximum pathsize
#define READ    1
#define WRITE   2
#define EXEC    4